/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import java.io.*;

import iic1102Package.*;

public class Palabras {

	private static String[] palabras;
	
	/*
	 * Dentro de getPalabra() usaremos el mtodo readLine(),
	 * el cual puede lanzar una excepcin, por lo tanto,
	 * como nosotros no "agarraremos" esa posible excepcin,
	 * la lanzaremos nuevamente para que otro la "agarre".
	 * 
	 */
	public static String getPalabra() throws IOException {
		
		File archivo = new File("wordlist.txt");
		
		//verificamos si el archivo existe y si tenemos acceso para abrirlo
		if(!archivo.exists() || !archivo.canRead())
			//si no existe o no podemos abrirlo, retornamos null
			return null;
		
		FileReader lector = new FileReader(archivo);
		BufferedReader buffer = new BufferedReader(lector);
		
		palabras = new String[86062];
		int total = 0;
		
		String linea;
		
		linea = buffer.readLine();
		while(linea != null) {
			palabras[total++] = linea;
			linea = buffer.readLine();			
		}
		
		/*
		 * Otra opcin para las ltimas 5 lneas (lo mismo, pero en menos lneas) sera:
		 * 
		 *		while((linea = buffer.readLine()) != null)
		 *			palabras[total++] = linea;
		 */
		
		buffer.close();
		lector.close();

		int x;
		//aqu pongo "length-1" porque los ndices del arreglo van de "0" a "n-1"
		x = Tools.randomAB(0, palabras.length - 1);

		return palabras[x];

	}

}
