/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import java.io.IOException;

import iic1102Package.*;

public class Admin {

	public static void main(String[] args) throws IOException {
		
		Interfaz.MostrarMensaje("Bienvenido al Sistema de Administracin de Usuarios de LenizTech");
		
		while(true) {
		
			int opcion;
			do {
				opcion = Interfaz.PedirEntero("Men:\n\n1. Agregar nuevo usuario.\n2. Editar un usuario existente.\n3. Salir del programa.");
			} while(opcion != 1 && opcion != 2 && opcion != 3);
			
			if(opcion == 1)
				agregarUsuario();
			else if(opcion == 2)
				editarUsuario();
			else
				break;
			
		}

	}
	
	public static void editarUsuario() throws IOException {
		
		String[] u, c;
		
		u = BaseDeDatos.getUsuarios();
		c = BaseDeDatos.getClaves();
		
		if(u == null || c == null || u.length != c.length) {
			
			Interfaz.MostrarMensaje("Error en la Base de Datos.");
			return; //salir del mtodo
			
		}
		
		String texto = "";
		for(int i = 0; i < u.length; ++i) {
			
			texto += u[i] + "\n";
			
		}
		
		Interfaz.MostrarMensaje("Usuarios:\n\n" + texto + "\n");
		
		String usuario;
		usuario = Interfaz.PedirString("Ingrese el nombre de usuario que quiere editar:");
		
		for(int i=0; i<u.length; ++i) {
			
			if(usuario.equals(u[i])) {
				
				do {
					
					u[i] = Interfaz.PedirString("Ingrese el nuevo nombre de usuario:");
					
				} while(u[i].equals(""));
				
				do {
					
					c[i] = Interfaz.PedirString("Ingrese la nueva clave:");
					
				} while(c[i].equals(""));
				
				c[i] = encriptar(c[i]);
				
				break; //salir del for para evitar ciclos innecesarios
				
			}
			
		}
		
		BaseDeDatos.setUsuariosClaves(u, c);
		
	}
	
	public static void agregarUsuario() throws IOException {
		
		String[] u, c;
		
		u = BaseDeDatos.getUsuarios();
		c = BaseDeDatos.getClaves();
		
		int largo;
		
		if(u == null || c == null || u.length != c.length) {
			
			largo = 0;
			
		} else {
			
			largo = u.length;
			
		}
		
		String[] u2, c2;
		
		//creo arreglos que tengan un espacio ms que el arreglo anterior
		u2 = new String[largo + 1];
		c2 = new String[largo + 1];
		
		//copio los arreglos antiguos en los nuevos arreglos
		for(int i=0; i<largo; ++i) {
			u2[i] = u[i];
			c2[i] = c[i];
		}
		
		do {
			u2[u2.length-1] = Interfaz.PedirString("Ingrese el nuevo nombre de usuario:");
				
		} while(u2[u2.length-1].equals(""));
				
		do {
			
			c2[c2.length-1] = Interfaz.PedirString("Ingrese la nueva clave:");
			
		} while(c2[c2.length-1].equals(""));
		
		c2[c2.length-1] = encriptar(c2[c2.length-1]);

		BaseDeDatos.setUsuariosClaves(u2, c2);
		
	}
	
	public static String encriptar(String x) {
		
		String enc = "";
		
		for(int i = x.length() - 1; i >= 0; --i)
			enc += (char) (x.charAt(i) - 2);

		return enc;

	}

}