/***
 * 
 * Felipe Brahm
 * Ayudante de Ctedra
 * Introduccin a la Programacin - IIC1102 Seccin 4
 * Pontificia Universidad Catlica de Chile
 *
 * lebrahm <at> uc <punto> cl
 * ICQ#50566818
 *
 * (CC)2006
 * 
 * */

import java.io.*;

public class BaseDeDatos {
	
	private static int MAX_USUARIOS = 300;
	private static String[] usuarios;
	private static String[] claves;

	public static String[] getUsuarios() throws IOException {
		
		File archivo = new File("datos.txt");
		
		//verificamos si el archivo existe y si tenemos acceso para abrirlo
		if(!archivo.exists() || !archivo.canRead())
			//si no existe o no podemos abrirlo, retornamos null
			return null;
		
		FileReader lector = new FileReader(archivo);
		BufferedReader buffer = new BufferedReader(lector);
		
		String linea;
		String[] temp = new String[MAX_USUARIOS];
		
		int total = 0;
		
		linea = buffer.readLine();
		while(linea != null && total < MAX_USUARIOS) {
			temp[total++] = linea.substring(0, linea.indexOf(":"));
			linea = buffer.readLine();
		}
		
		lector.close();
		buffer.close();
		
		//copio el arreglo temporal al arreglo "usuarios"
		usuarios = new String[total];
		for(int i = 0; i < total; ++i)
			usuarios[i] = temp[i];

		return usuarios;
		
	}
	
	public static String[] getClaves() throws IOException {
		
		File archivo = new File("datos.txt");
		
		//verificamos si el archivo existe y si tenemos acceso para abrirlo
		if(!archivo.exists() || !archivo.canRead())
			//si no existe o no podemos abrirlo, retornamos null
			return null;
		
		FileReader lector = new FileReader(archivo);
		BufferedReader buffer = new BufferedReader(lector);
		
		String linea;
		String[] temp = new String[MAX_USUARIOS];
		
		int total = 0;
		
		linea = buffer.readLine();
		while(linea != null && total < MAX_USUARIOS) {
			temp[total++] = linea.substring(linea.indexOf(":")+1);
			linea = buffer.readLine();
		}
		
		lector.close();
		buffer.close();
		
		//copio el arreglo temporal al arreglo "claves"
		claves = new String[total];
		for(int i = 0; i < total; ++i)
			claves[i] = temp[i];

		return claves;

	}
	
	public static boolean setUsuariosClaves(String[] u, String[] c) throws IOException {
		
		if(u.length != c.length)
			return false;
			
		usuarios = u;
		claves = c;
		
		File archivo = new File("datos.txt");
		FileWriter escritor = new FileWriter(archivo);
		
		for(int i = 0; i<usuarios.length; ++i) {
			escritor.write(usuarios[i] + ":" + claves[i]);
			if(i+1 < usuarios.length) {
				/*
				 * Para que Notepad lea bien el archivo,
				 * los saltos de lnea deben ser con \r\n
				 * 
				 * Windows -> \r\n
				 * MaxOS -> \r
				 * Unix -> \n
				 * MaxOS/X -> \n
				 * 
				 * Esto lo pongo nada ms que como un "dato anecdtico",
				 * pero NO es relevante para este curso.
				 * 
				 * */
				escritor.write('\r');
				escritor.write('\n');
			}
		}
		
		escritor.close();

		return true;
		
	}
	
}